/* Tabela VOOTRECHO: VOOTRECHO */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela VOOTRECHO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela VOOTRECHO,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_VOOTRECHO
AFTER DELETE OR INSERT OR UPDATE
ON VOOTRECHO FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.NRVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' NrVoo=' || :OLD.NRVOO;
      END IF;
      
      IF :OLD.CDTRECHO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTrecho' || :OLD.CDTRECHO;
      END IF;
      
      IF :OLD.CDBASEORI IS NOT NULL THEN
         V_DESC := V_DESC || ' CdBaseori=' || :OLD.CDBASEORI;
      END IF;
      
      IF :OLD.CDBASEDES IS NOT NULL THEN
         V_DESC := V_DESC || ' CdBaseDes=' || :OLD.CDBASEDES;
      END IF;
      
      IF :OLD.HRDECOLVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' HrDecolVoo=' || :OLD.HRDECOLVOO;
      END IF;
      
      IF :OLD.HRPOUSOVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' HrPousoVoo=' || :OLD.HRPOUSOVOO;
      END IF;
      
      IF :OLD.IDTIPAJUSFAT IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTipoAjusteFatu=' || :OLD.IDTIPAJUSFAT;
      END IF;
      
      IF :OLD.IDSITVOOTRE IS NOT NULL THEN
         V_DESC := V_DESC || ' IdSituVooTre=' || :OLD.IDSITVOOTRE;
      END IF;
     
      IF :OLD.DTULTATUTREC IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtuRec=' || :OLD.DTULTATUTREC;
      END IF;

      IF :OLD.QTHRPREPVOO IS NOT NULL THEN
         V_DESC := V_DESC || ' QtHorasPrepVoo=' || :OLD.QTHRPREPVOO;
      END IF;
      
      IF :OLD.CDLOCAFATCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdLocaFatCia=' || :OLD.CDLOCAFATCIA;
      END IF;
      
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDCIA || '|' || :OLD.NRVOO || '|' || :OLD.CDTRECHO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL ) OR
            (:OLD.CDCIA        <> :NEW.CDCIA    ) OR
            (:OLD.NRVOO        <> :NEW.NRVOO    ) OR
            (:OLD.CDTRECHO     <> :NEW.CDTRECHO ) OR
            (:OLD.CDBASEORI    <> :NEW.CDBASEORI) OR
            (:OLD.CDBASEDES    <> :NEW.CDBASEDES) OR
            (NVL(:OLD.HRDECOLVOO,   ' ') <> NVL(:NEW.HRDECOLVOO,   ' ')) OR 
            (NVL(:OLD.HRPOUSOVOO,   ' ') <> NVL(:NEW.HRPOUSOVOO,   ' ')) OR
            (NVL(:OLD.IDTIPAJUSFAT, ' ') <> NVL(:NEW.IDTIPAJUSFAT, ' ')) OR
            (:OLD.IDSITVOOTRE  <> :NEW.IDSITVOOTRE) OR
            (NVL(:OLD.DTULTATUTREC, SYSDATE) <> NVL(:NEW.DTULTATUTREC, SYSDATE)) OR
            (NVL(:OLD.QTHRPREPVOO, 0)        <> NVL(:NEW.QTHRPREPVOO, 0)) OR
            (NVL(:OLD.CDLOCAFATCIA, ' ')      <> NVL(:NEW.CDLOCAFATCIA, ' ')) THEN 
           
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL ,' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.NRVOO, ' ') <> NVL(:NEW.NRVOO, ' ') THEN
               V_DESC := V_DESC || ' NrVoo=' || :OLD.NRVOO || '|' || :NEW.NRVOO;
            END IF;
            
            IF NVL(:OLD.CDTRECHO, ' ') <> NVL(:NEW.CDTRECHO, ' ') THEN
               V_DESC := V_DESC || ' CdTrecho=' || :OLD.CDTRECHO || '|' || :NEW.CDTRECHO;
            END IF;
            
            IF NVL(:OLD.CDBASEORI, ' ') <> NVL(:NEW.CDBASEORI, ' ') THEN
               V_DESC := V_DESC || ' CdBaseori=' || :OLD.CDBASEORI || '|' || :NEW.CDBASEORI;
            END IF;
            
            IF NVL(:OLD.CDBASEDES, ' ') <> NVL(:NEW.CDBASEDES, ' ') THEN
               V_DESC := V_DESC || ' CdBaseDes=' || :OLD.CDBASEDES || '|' || :NEW.CDBASEDES;
            END IF;
            
            IF NVL(:OLD.HRDECOLVOO, ' ') <> NVL(:NEW.HRDECOLVOO ,' ') THEN
               V_DESC := V_DESC || ' HrDecolVoo=' || :OLD.HRDECOLVOO || '|' || :NEW.HRDECOLVOO;
            END IF;
            
            IF NVL(:OLD.HRPOUSOVOO, ' ') <> NVL(:NEW.HRPOUSOVOO ,' ') THEN
               V_DESC := V_DESC || ' HrPousoVoo=' || :OLD.HRPOUSOVOO || '|' || :NEW.HRPOUSOVOO;
            END IF;
            
            IF NVL(:OLD.IDTIPAJUSFAT, ' ') <> NVL(:NEW.IDTIPAJUSFAT ,' ') THEN
               V_DESC := V_DESC || ' IdTipoAjusteFatu=' || :OLD.IDTIPAJUSFAT || '|' || :NEW.IDTIPAJUSFAT;
            END IF;
            
            IF NVL(:OLD.IDSITVOOTRE, ' ') <> NVL(:NEW.IDSITVOOTRE ,' ') THEN
               V_DESC := V_DESC || ' IdSituVooTre=' || :OLD.IDSITVOOTRE || '|' || :NEW.IDSITVOOTRE;
            END IF;
           
            IF NVL(:OLD.DTULTATUTREC, SYSDATE) <> NVL(:NEW.DTULTATUTREC, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtuRec=' || :OLD.DTULTATUTREC || '|' || :NEW.DTULTATUTREC;
            END IF;
      
            IF NVL(:OLD.QTHRPREPVOO, 0) <> NVL(:NEW.QTHRPREPVOO, 0) THEN
               V_DESC := V_DESC || ' QtHorasPrepVoo=' || :OLD.QTHRPREPVOO || '|' || :NEW.QTHRPREPVOO;
            END IF;
            
            IF NVL(:OLD.CDLOCAFATCIA, ' ') <> NVL(:NEW.CDLOCAFATCIA, ' ') THEN
               V_DESC := V_DESC || ' CdLocaFatCia=' || :OLD.CDLOCAFATCIA || '|' || :NEW.CDLOCAFATCIA;
            END IF;
            
            
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDCIA || '|' || :OLD.NRVOO || '|' || :OLD.CDTRECHO;
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL ,' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
          
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' Cia=' || :NEW.CDCIA;
         END IF;
          
         IF NVL(:OLD.NRVOO, ' ') <> NVL(:NEW.NRVOO, ' ') THEN
            V_DESC := V_DESC || ' NrVoo=' || :NEW.NRVOO;
         END IF;
          
         IF NVL(:OLD.CDTRECHO, ' ') <> NVL(:NEW.CDTRECHO, ' ') THEN
            V_DESC := V_DESC || ' CdTrecho=' || :NEW.CDTRECHO;
         END IF;
          
         IF NVL(:OLD.CDBASEORI, ' ') <> NVL(:NEW.CDBASEORI, ' ') THEN
            V_DESC := V_DESC || ' CdBaseori=' || :NEW.CDBASEORI;
         END IF;
          
         IF NVL(:OLD.CDBASEDES, ' ') <> NVL(:NEW.CDBASEDES, ' ') THEN
            V_DESC := V_DESC || ' CdBaseDes=' || :NEW.CDBASEDES;
         END IF;
          
         IF NVL(:OLD.HRDECOLVOO, ' ') <> NVL(:NEW.HRDECOLVOO, ' ') THEN
            V_DESC := V_DESC || ' HrDecolVoo=' || :NEW.HRDECOLVOO;
         END IF;
          
         IF NVL(:OLD.HRPOUSOVOO, ' ') <> NVL(:NEW.HRPOUSOVOO, ' ') THEN
            V_DESC := V_DESC || ' HrPousoVoo=' || :NEW.HRPOUSOVOO;
         END IF;
          
         IF NVL(:OLD.IDTIPAJUSFAT, ' ') <> NVL(:NEW.IDTIPAJUSFAT, ' ') THEN
            V_DESC := V_DESC || ' IdTipoAjusteFatu=' || :NEW.IDTIPAJUSFAT;
         END IF;
          
         IF NVL(:OLD.IDSITVOOTRE, ' ') <> NVL(:NEW.IDSITVOOTRE, ' ') THEN
            V_DESC := V_DESC || ' IdSituVooTre=' || :NEW.IDSITVOOTRE;
         END IF;
         
         IF NVL(:OLD.DTULTATUTREC, SYSDATE) <> NVL(:NEW.DTULTATUTREC, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtuRec=' || :NEW.DTULTATUTREC;
         END IF;
    
         IF NVL(:OLD.QTHRPREPVOO, 0) <> NVL(:NEW.QTHRPREPVOO, 0) THEN
            V_DESC := V_DESC || ' QtHorasPrepVoo=' || :NEW.QTHRPREPVOO;
         END IF;
          
         IF NVL(:OLD.CDLOCAFATCIA, ' ') <> NVL(:NEW.CDLOCAFATCIA, ' ') THEN
            V_DESC := V_DESC || ' CdLocaFatCia=' || :NEW.CDLOCAFATCIA;
         END IF;
          
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDCIA || '|' || :NEW.NRVOO || '|' || :NEW.CDTRECHO;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('VOOTRECHO', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_VOOTRECHO','5.85.xxx'); END;
/

