/* Sistemas Integrados TECNISA
   
Nome: 2500_PLATRGO_NUTRIENTES_CALORIAS

Descrio:
A trigger ir atualizar os campos 'Compe Clculo de Caloria', 'Caloria' e 'Fator de Cculo de Caloria'
(Fator Nutricional) da tabela de nutrientes sempre que forem informados novos nutrietes na tela
Parmetros de Planejamento, aba Geral, aba Cardpio.

Criao:
09/2014 - Rodrigo Oliveira
*/
CREATE OR REPLACE 
TRIGGER NUTRIENTES_CALORIAS
AFTER UPDATE OR INSERT 
ON PARAMGERAL FOR EACH ROW

BEGIN
   /*Verifica se algum dos nutrientes da paramgeral foi modificado*/
   IF (NVL(:NEW.CDCALORIAS, '0000') <> NVL(:OLD.CDCALORIAS, '0000'))     OR
      (NVL(:NEW.CDCARBOHIDRA, '0000') <> NVL(:OLD.CDCARBOHIDRA, '0000')) OR
      (NVL(:NEW.CDPROTEINA, '0000') <> NVL(:OLD.CDPROTEINA, '0000'))     OR
      (NVL(:NEW.CDLIPIDIOS, '0000') <> NVL(:OLD.CDLIPIDIOS, '0000'))     OR
      (NVL(:NEW.CDALCOOL, '0000') <> NVL(:OLD.CDALCOOL, '0000'))         THEN
      
      /*Limpa os dados do nutriente caloria, dos nutrientes que compem o clculo da caloria e do fator nutricional na tabela de nutrientes*/
      UPDATE NUTRIENTE
      SET IDCALORIAS = 'N',
          IDKCAL = 'N',
          VRFATORNUTR = NULL;
      
      /*Atualiza os nutrientes carboidrado e proteina para os mesmos comporem o clculo de caloria e terem o fator nutricional = 4*/    
      UPDATE NUTRIENTE
      SET IDCALORIAS = 'S',
          VRFATORNUTR = 4
      WHERE (CDNUTRIENTE = :NEW.CDCARBOHIDRA) OR
            (CDNUTRIENTE = :NEW.CDPROTEINA);
      
      /*Atualiza o nutriente lipidio para o mesmo compor o clculo de caloria e ter o fator nutricional = 9*/
      UPDATE NUTRIENTE
      SET IDCALORIAS = 'S',
          VRFATORNUTR = 9
      WHERE CDNUTRIENTE = :NEW.CDLIPIDIOS;
      
      /*Atualiza o nutriente lcool para o mesmo compor o clculo de caloria e ter o fator nutricional = 7*/
      UPDATE NUTRIENTE
      SET IDCALORIAS = 'S',
          VRFATORNUTR = 7
      WHERE CDNUTRIENTE = :NEW.CDALCOOL;
      
      /*Atualiza o nutriente caloria para o mesmo ser marcado como caloria na tabela nutriente*/
      UPDATE NUTRIENTE
      SET IDKCAL = 'S'
      WHERE CDNUTRIENTE = :NEW.CDCALORIAS;

   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('NUTRIENTES_CALORIAS','5.80.xxx'); END;
/